// ============================================================
// Project				:	CityRPG
// Author				:	Iban
// Description			:	Code that operates the Status GUI.
//								Document written in monospace
//								with 3-space tabbing.
// ============================================================

// CityRPG variable I will be using to help test crashing.
$ibansucks = false;

// ============================================================
// Section 1 : Initiation
// ============================================================
$CRPG_C::Version = 3.0;
$CRPG_C::Password = "breastmilk";

$CRPG_C::Path = "Add-Ons/Client_CityRPG/";

exec($CRPG_C::Path @ "profiles/CRPGButtonProfile.cs");
exec($CRPG_C::Path @ "profiles/CRPGCashNoticeProfile.cs");
exec($CRPG_C::Path @ "profiles/CRPGScrollProfile.cs");
exec($CRPG_C::Path @ "profiles/CRPGTextListProfile.cs");
exec($CRPG_C::Path @ "profiles/CRPGWindowProfile.cs");

exec($CRPG_C::Path @ "scripts/admin.cs");
exec($CRPG_C::Path @ "scripts/bank.cs");
exec($CRPG_C::Path @ "scripts/commands.cs");
exec($CRPG_C::Path @ "scripts/police.cs");
exec($CRPG_C::Path @ "scripts/stats.cs");
exec($CRPG_C::Path @ "scripts/status.cs");
exec($CRPG_C::Path @ "scripts/vehicle.cs");

// If you're going to be using my code for ConnectArgs, take a look at this.
// It allows multiple mods to send name/version data over one paramter (parameter 8).
// If you follow the instructions in this and add it to your mod, we can live
// peacefulle. Otherwise, I will literally find out where you live, and
// rape you to death.
exec($CRPG_C::Path @ "scripts/Support_ModVersion.cs");

$remapDivision[$remapCount]	= "CityRPG";
$remapName[$remapCount]			= "Toggle Status";
$remapCmd[$remapCount]			= "CityRPG_toggleStatus";
$remapCount++;

$remapName[$remapCount]			= "Toggle Villainy";
$remapCmd[$remapCount]			= "CityRPG_toggleVillainy";
$remapCount++;

$remapName[$remapCount]			= "Open Admin GUI";
$remapCmd[$remapCount]			= "CityRPG_openAdmin";
$remapCount++;

$remapName[$remapCount]			= "Open Stats GUI";
$remapCmd[$remapCount]			= "CityRPG_openStats";
$remapCount++;

// Add the cool green coloring.
JS_serverList.profile.fontColors[9] = "0 128 128 255";

// ============================================================
// Section 1 : clientCmds
// ============================================================
function clientCmdDisplayCRPGComponents()
{
	$CRPG_C::Active = true;
	CityRPG_Status.setVisible(true);
	CityRPG_Status.fixPosition();
	CRPG_CreateDatumSO();
}

function clientCmdDisplayCRPGError(%error)
{
	%error = strReplace(getTaggedString(%error), "CRPG_", "");
	
	if($pref::Video::useSmallPlantErrors && isFile($CRPG_C::Path @ "images/" @ %error @ "_Small.png"))
	{
		cancel(HUD_PlantErrorSmall.hideSchedule);
		HUD_PlantErrorSmall.setVisible(true);
		HUD_PlantErrorSmall.setBitmap($CRPG_C::Path @ "images/" @ %error @ "_Small");
		HUD_PlantErrorSmall.hideSchedule = HUD_PlantErrorSmall.schedule(1000, "setVisible", false);
	}
	else if(isFile($CRPG_C::Path @ "images/" @ %error @ ".png"))
	{
		cancel(HUD_PlantError.hideSchedule);
		HUD_PlantError.setVisible(true);
		HUD_PlantError.setBitmap($CRPG_C::Path @ "images/" @ %error);
		HUD_PlantError.hideSchedule = HUD_PlantError.schedule(1000, "setVisible", false);
	}
	else
	{
		warn("clientCmdDisplayCRPGError() : Could not find \"" @ getTaggedString(%error) @ "\"!");
	}
}

function clientCmdDisplayCRPGGUI(%gui)
{
	if($CRPG_C::Active)
	{
		%gui = "CRPG_" @ %gui;
		
		if(isObject(%gui))
		{
			canvas.pushDialog(%gui);
		}
		else
		{
			error(%gui @ " does not exist.");
		}
	}
}

function clientCmdDisplayCRPGWelcome(%easter)
{
	if($CRPG_C::Active && !$ibansucks)
	{
		%file = "Add-Ons/Client_CityRPG/images/logo";
		
		if(isFile(%file @ "_" @ %easter @ ".png"))
			%file = %file @ "_" @ %easter;
		
		%ext	= getWord(getRes(), 0) SPC mCeil((getWord(getRes(), 0) / 1440) * 600);
		%pos	= "0" SPC mFloor(getWord(getRes(), 1) - getWord(%ext, 1) + 5);
		%logo	= new GuiBitmapCtrl()
		{
			profile				= "HUDBrickNameProfile";
			horizSizing			= "right";
			vertSizing			= "bottom";
			position				= %pos;
			extent				= %ext;
			minExtent			= "0 0";
			visible				= true;
			bitmap				= %file;
			wrap					= false;
			lockAspectRatio	= true;
			alignLeft			= true;
			overflowImage		= false;
			keepCached			= false;
		};
		
		PlayGUI.add(%logo);
		%logo.schedule(5000, "delete");
	}
}

function clientCmdSetCRPGStatus(%names1, %names2, %names3, %names4, %names5, %values1, %values2, %values3, %values4, %values5)
{	
	if($CRPG_C::Active)
	{
		for(%a = 1; %a <= 5; %a++)
			%names = %names @ %names[%a];
			
		for(%a = 1; %a <= 5; %a++)
			%values = %values @ %values[%a];
		
		// Interesting bug with changing maps in a non-dedicated server.
		if(!isObject(MyCityRPGDatum))
			clientCmdDisplayCRPGComponents();
		
		for(%a = 0; %a < getFieldCount(%names); %a++)
		{
			%name = getField(%names, %a);
			%value = getField(%values, %a);
			
			MyCityRPGDatum.var[%name] = %value;
		}
		
		MyCityRPGDatum.hasData = true;
		
		if(isObject(CRPG_Bank))
			adjustCityRPGBank();
		
		if(isObject(CityRPG_Status))
			adjustCityRPGStatus();
		
		if(isObject(CRPG_Stats))
			adjustCityRPGStats();
	}
}

// ============================================================
// Section 3 : Functions
// ============================================================
function CRPG_CreateDatumSO()
{
	if(isObject(MyCityRPGDatum))
	{
		MyCityRPGDatum.delete();
	}
	
	new scriptObject(MyCityRPGDatum)
	{
		hasData = false;
	};
}

function CRPG_DeleteDatumSO()
{
	if(isObject(MyCityRPGDatum))
	{
		MyCityRPGDatum.delete();
	}
}

function CRPG_Pop()
{
	CityRPG_Status_NoData.setVisible(true);
	CityRPG_Status_Data.setVisible(false);
	CityRPG_Status.setVisible(false);
	
	CRPG_DeleteDatumSO();
	deleteVariables("$CRPG::*");
	deleteVariables("$CRPG_Temp::");
	$CRPG_C::Active = false;
	$CRPG_C::RuinedWrenchGUI = false;
}

function CRPG_ReportBug()
{
	if(isObject(RTB_ModManager))
	{
		Canvas.pushDialog(RTB_ModManager);
		RTBMM_ModsView_Init();
		RTBMM_ModsView_Report(537);
		RTBMM_Report_Summary.setText("Put a short description of the bug in here.");
		RTBMM_Report_Description.setText("Please explain in this box what the bug is and how you came across it.");
	}
}

// ============================================================
// Section 4 : Package
// ============================================================
package CityRPG_Client_MainPackage
{
	function Canvas::popDialog(%canvas, %gui)
	{
		%result = parent::popDialog(%canvas, %gui);
		
		if($CRPG_C::Active)
		{
			switch(%gui.getID())
			{
				case BrickSelectorDlg.getID() :
					CityRPG_Status.setVisible(true);
				
				case AdminGUI.getID() :
					if($IamAdmin == 2)
					{
						CRPG_AdminButton.setVisible(false);
					}
			}
		}
		
		return %result;
	}
	
	function Canvas::pushDialog(%canvas, %gui)
	{
		%result = parent::pushDialog(%canvas, %gui);
		
		if($CRPG_C::Active)
		{
			switch(%gui.getID())
			{
				case BrickSelectorDlg.getID() :
					CityRPG_Status.setVisible(false);
				
				case AdminGUI.getID() :
					CRPG_AdminButton.setVisible(true);
			}
		}
		
		return %result;
	}
	
	function disconnectedCleanup(%bool)
	{
		%result = parent::disconnectedCleanup(%bool);
		CRPG_Pop();
		return %result;
	}
	
	function resetCanvas()
	{
		%result = parent::resetCanvas();
		
		if($CRPG_C::Active)
		{
			CityRPG_Status.fixPosition();
			
			if(isObject(HUD_CrimeEnabled))
				HUD_CrimeEnabled.position = getWords(vectorSub(HUD_SuperShift.position, "0 37"), 0, 1);
		}
		
		return %result;
	}
	
	function ServerSO::serialize(%so)
	{
      %serialized = parent::serialize(%so);
      
		// This will only replace black (uncolorized) with my special color.
		// Passworded / Full still takes priority.
		if(getSubStr(%so.name, 0, 14) $= "Iban's CityRPG")
		{
			// Remove black special coloring (it defaults to black, anyways).
			%serialized = strreplace(%serialized, "\c0", "");
			
			// Set \c9 infront of everything.
			// If RTB or anything else put another color code before this,
			// the second color code (e.g. not \c9) will take effect.
			%serialized = "\c9" @ %serialized;
		}
		
      return %serialized;
	}
	
	function wrenchVehicleSpawnDlg::onWake(%gui)
	{
		%result = parent::onWake(%canvas, %gui);
		
		if($CRPG_C::Active)
		{
			if($IamAdmin < 2)
			{
				$CRPG_C::RuinedWrenchGUI = true;
				
				WrenchVehicleSpawn_Vehicles.clear();
				%vehicles = MyCityRPGDatum.var["GARAGE"];
				%vcount = getWordCount(%vehicles);
				
				if(%vcount)
				{
					for(%a = 0; %a < %vcount; %a++)
					{
						%vehicle = getWord(%vehicles, %a);
						
						if(isObject(%vehicle))
							WrenchVehicleSpawn_Vehicles.add(%vehicle.uiName, %vehicle.getID());
					}
					
					WrenchVehicleSpawn_Vehicles.sort();
					WrenchVehicleSpawn_Vehicles.addFront("None", 0);
				}
				else
				{
					WrenchVehicleSpawn_Vehicles.add("No Vehicles in Garage", 0);
					WrenchVehicleSpawn_Vehicles.setSelected(0);
				}
			}
			else if($CRPG_C::RuinedWrenchGUI)
			{
				// So Badspot can bitch at me if I break something.
				echo("CityRPG - Re-Assembling Vehicle Wrench Dialog List.");
				// Remove the temp property so this process does not happen twice.
				$CRPG_C::RuinedWrenchGUI = false;
				
				WrenchVehicleSpawn_Vehicles.clear();
				
				// This is a pretty uber leet hax.
				// Repopulate the wrench dialog.
				
				// In another player'ss server, ServerConnection group has the datablocks and DataBlockGroup has none.
				// If our DataBlockGroup has members, we want to scan through it instead of SC.
				%group = DataBlockGroup.getCount() ? DataBlockGroup : ServerConnection;
				
				for(%a = 0; %a < %group.getCount(); %a++)
				{
					%db = %group.getObject(%a);
					
					// It's so fucking easy, a caveman could do it!
					// If %db is rideable and has a name, add it.
					if(%db.rideAble && %db.uiName !$= "")
						WrenchVehicleSpawn_Vehicles.add(%db.uiName, %db.getID());
					
					// .position only appears on instantiated objects.
					// Datablocks are not instances.
					// We load datablocks before our first object
					// so once we find a position property, we know we're at
					// the end of the datablock list.
					else if(%db.position !$= "")
						break;
				}
				
				WrenchVehicleSpawn_Vehicles.sort();
				WrenchVehicleSpawn_Vehicles.addFront("None", 0);
			}
		}
		
		return %result;
	}
};

activatePackage(CityRPG_Client_MainPackage);
