// ============================================================
// Project				:	CityRPG
// Author				:	Iban
// Description			:	Code that operates the Status GUI.
// ============================================================

// ============================================================
// Section 1 : Object Initiation
// ============================================================
while(isObject(CityRPG_Status))
{
	CityRPG_Status.delete();
}

exec($CRPG_C::Path @ "guis/status.gui");

if(isObject(CityRPG_Status))
{
	PlayGUI.add(CityRPG_Status);
	CityRPG_Status.schedule(32, "fixPosition");
	
	if(!$CRPG_C::Active)
	{
		CityRPG_Status.setVisible(false);
	}
	else
	{
		CityRPG_Status.setVisible(true);
	}
}

$CRPG_C::Module::Status::Font = "<just:center><color:ffffff>";

// ============================================================
// Section 2 : Functions
// ============================================================
function adjustCityRPGStatus()
{
	CityRPG_Status.fixPosition();
	
	CityRPG_Status_NoData.setVisible(false);
	CityRPG_Status_Data.setVisible(true);
	
	// Cash
	CityRPG_Status_Text_1.setText($CRPG_C::Module::Status::Font @ "<color:00ff00>$" @ MyCityRPGDatum.var["MONEY"]);
	CityRPG_Status_Icon_1.setBitmap($CRPG_C::Path @ "images/icons/Icon_Money");
	
	// Hunger
	%hunger = MyCityRPGDatum.var["HUNGER"];
	
	if(%hunger >= 100)
		%hunger = "<color:00ff00>" @ %hunger;
	else if(%hunger <= 0)
		%hunger = "<color:ff0000>" @ %hunger;
	else
	{
		%green = 256 * (%hunger / 100);
		%red = 256 - %green;
		%blue = "00";
		
		// Green
		%tens = mFloor(%green / 16);
		
		if(%tens > 9)
			switch(%tens)
			{
				case 10: %tens = "a";
				case 11: %tens = "b";
				case 12: %tens = "c";
				case 13: %tens = "d";
				case 14: %tens = "e";
				case 15: %tens = "f";
			}
		
		%ones = %green % 16;
		
		if(%ones > 9)
			switch(%ones)
			{
				case 10: %ones = "a";
				case 11: %ones = "b";
				case 12: %ones = "c";
				case 13: %ones = "d";
				case 14: %ones = "e";
				case 15: %ones = "f";
			}
		
		%green = %tens @ %ones;
		
		// Red
		%tens = mFloor(%red / 16);
		
		if(%tens > 9)
			switch(%tens)
			{
				case 10: %tens = "a";
				case 11: %tens = "b";
				case 12: %tens = "c";
				case 13: %tens = "d";
				case 14: %tens = "e";
				case 15: %tens = "f";
			}
		
		%ones = %red % 16;
		
		if(%ones > 9)
			switch(%ones)
			{
				case 10: %ones = "a";
				case 11: %ones = "b";
				case 12: %ones = "c";
				case 13: %ones = "d";
				case 14: %ones = "e";
				case 15: %ones = "f";
			}
		
		%red = %tens @ %ones;
		
		%hunger = "<color:" @ %red @ %green @ %blue @ ">" @ %hunger;
	}
	
	CityRPG_Status_Text_2.setText($CRPG_C::Module::Status::Font @ %hunger @ "% Full");
	CityRPG_Status_Icon_2.setBitmap($CRPG_C::Path @ "images/icons/Icon_Hunger");
	
	// Resources
	if(MyCityRPGDatum.var["PLASTIC"])
	{
		if(MyCityRPGDatum.var["PLASTIC"] > 1)
		{
			%plural = "s";
		}
		
		CityRPG_Status_Text_3.setText($CRPG_C::Module::Status::Font @ MyCityRPGDatum.var["PLASTIC"] @ " Chunk" @ %plural);
	}
	else
	{
		CityRPG_Status_Text_3.setText($CRPG_C::Module::Status::Font @ "No Plastic");
	}
	CityRPG_Status_Icon_3.setBitmap($CRPG_C::Path @ "images/icons/Icon_Plastic");
	
	// Lot Owner
	if(MyCityRPGDatum.var["JOB"] $= "Convict")
	{
		CityRPG_Status_Text_4.setText($CRPG_C::Module::Status::Font @ MyCityRPGDatum.var["JOB"]);
		CityRPG_Status_Icon_4.setBitmap($CRPG_C::Path @ "images/icons/Icon_Crime_Inmate");
	}
	else
	{
		if(MyCityRPGDatum.var["LOTOWNER"] !$= "")
		{
			CityRPG_Status_Text_4.setText($CRPG_C::Module::Status::Font @ MyCityRPGDatum.var["LOTOWNER"]);
			CityRPG_Status_Icon_4.setBitmap($CRPG_C::Path @ "images/icons/Icon_Lot");
		}
		// Job
		else
		{
			CityRPG_Status_Text_4.setText($CRPG_C::Module::Status::Font @ MyCityRPGDatum.var["JOBNAME"]);
			CityRPG_Status_Icon_4.setBitmap($CRPG_C::Path @ "images/icons/Icon_Job");
		}
	}
	
	// Wanted Level
	if(MyCityRPGDatum.var["SENTENCE"])
	{
		CityRPG_Status_Icon_5.setVisible(true);
		CityRPG_Status_Text_5.setVisible(true);
		
		for(%a = 1; %a <= 6; %a++)
		{
			%icon = "CityRPG_Status_Star_" @ %a;
			%icon.setVisible(false);
		}
		
		if(MyCityRPGDatum.var["SENTENCE"] > 1)
		{
			%plural = "s";
		}
		
		CityRPG_Status_Text_5.setText($CRPG_C::Module::Status::Font @ "<color:fde689>" @ MyCityRPGDatum.var["SENTENCE"] @ " Tick" @ %plural @ " Left");
		CityRPG_Status_Icon_5.setBitmap($CRPG_C::Path @ "images/icons/Icon_Crime_Jailed");
	}
	else
	{
		CityRPG_Status_Icon_5.setVisible(false);
		CityRPG_Status_Text_5.setVisible(false);
		
		for(%a = 1; %a <= 6; %a++)
		{
			%icon = "CityRPG_Status_Star_" @ %a;
			%icon.setVisible(%a <= MyCityRPGDatum.var["WANTEDLEVEL"]);
			%icon.setBitmap($CRPG_C::Path @ "images/icons/Icon_Crime_Wanted");
		}
	}
	
	// Gender
	switch(MyCityRPGDatum.var["GENDER"])
	{
		case 0: CityRPG_Status_Icon_6.setBitmap($CRPG_C::Path @ "images/icons/Icon_Gender_Unknown");
		case 1: CityRPG_Status_Icon_6.setBitmap($CRPG_C::Path @ "images/icons/Icon_Gender_Male");
		case 2: CityRPG_Status_Icon_6.setBitmap($CRPG_C::Path @ "images/icons/Icon_Gender_Fem");
	}
	
	// Student
	if(MyCityRPGDatum.var["STUDENT"] == 0)
	{
		CityRPG_Status_Icon_7.setBitmap($CRPG_C::Path @ "images/icons/Icon_Edu_Lv" @ MyCityRPGDatum.var["EDUCATION"]);
	}
	else if(MyCityRPGDatum.var["STUDENT"] == 1)
	{
		CityRPG_Status_Icon_7.setBitmap($CRPG_C::Path @ "images/icons/Icon_Edu_Almost");
	}
	else
	{
		CityRPG_Status_Icon_7.setBitmap($CRPG_C::Path @ "images/icons/Icon_Edu_Student");
	}
	
	// Debt
	if(MyCityRPGDatum.var["DEBT"] > 0)
	{
		CityRPG_Status_Icon_8.setBitmap($CRPG_C::Path @ "images/icons/Icon_Debt");
		CityRPG_Status_Icon_8.setVisible(true);
	}
	else
	{
		CityRPG_Status_Icon_8.setVisible(false);
	}
}

function CityRPG_toggleStatus(%button)
{
	if($CRPG_C::Active)
	{
		if(%button)
		{
			if(!CityRPG_Status.moving)
			{
				%xPos = getWord(CityRPG_Status.position, 0);
				%distFromZero = %xPos * -1;
				%xExt = getWord(CityRPG_Status.extent, 0);
				
				// If we're hiding
				if(%xPos >= 0)
				{
					PlayGUI.hideStatusBox(%distFromZero - (%xExt - 22), 10, 1);
					CityRPG_Status.hidden = true;
					CityRPG_Status.unhidden = false;
				}
				// If we're unhiding.
				else
				{
					PlayGUI.hideStatusBox(%distFromZero, 10, 1);
					setScrollMode(-1);
					CityRPG_Status.hidden = false;
					CityRPG_Status.unhidden = true;
				}
				
				CityRPG_Status.moving = true;
			}
		}
	}
}

function CityRPG_Status::fixPosition(%gui)
{
	%gui.position = getWord(%gui.position, 0) SPC getWord(HUD_PaintBox.position, 1) - (getWord(%gui.getExtent(), 1) + 8);
	return %gui.position;
}

function PlayGUI::hideStatusBox(%gui, %xMovement, %steps, %currStep)
{
	cancel(%gui.movementSchedule);
	
	%move = mFloor(%xMovement / %steps);
	
	%xLoc = getWord(CityRPG_Status.position, 0);
	%yLoc = getWord(CityRPG_Status.position, 1);
	%newXLoc = %xLoc + %move;
	
	CityRPG_Status.position = %newXLoc SPC %yLoc;
	
	if(%currStep < %steps)
	{
		CityRPG_Status.moveSchedule = %gui.schedule(250 / %steps, "hideStatusBox", %xMovement, %steps, %currStep + 1);
	}
	else
	{
		CityRPG_Status.moving = false;
	}
}
